;#########################################################################################################
;###################*******************************#######################################################
;###################  B L I N D         C R Y P T  #######################################################
;###################  blind_crypt.tnick@yahoo.com  #######################################################
;###################_______________________________#######################################################
;#########################################################################################################

;
;					# Main window.asm #
;
.386
option casemap:none
.CODE

MainW_Create		proc
;it creates a unique class for the window and then the window itself
LOCAL 	wc			:WNDCLASSEX 
LOCAL	SYST		:SYSTEMTIME
	
	INVOKE	GetSystemTime,				addr SYST
	;use this to generate a unique name for the class
	mov		ecx,						OFFSET MainWndClassName
	add		ecx,						8
	
	mov		ax,							SYST.wDayOfWeek
	add		al,							30h
	mov		byte ptr [ecx+0],			al
	mov		ax,							SYST.wHour
	shl		ax,							4
	shr		al,							4
	add		ax,							3030h
	mov		word ptr [ecx+1],			ax
	mov		ax,							SYST.wMinute
	shl		ax,							4
	shr		al,							4
	add		ax,							3030h
	mov		word ptr [ecx+3],			ax
	mov		ax,							SYST.wSecond
	shl		ax,							4
	shr		al,							4
	add		ax,							3030h
	mov		word ptr [ecx+5],			ax
	mov		ax,							SYST.wMilliseconds
	shl		ax,							4
	shr		al,							4
	add		ax,							3030h
	mov		word ptr [ecx+7],			ax
	
	;fill the structure
    mov   	wc.cbSize,					SIZEOF WNDCLASSEX 
    mov   	wc.style, 					CS_BYTEALIGNCLIENT or CS_BYTEALIGNWINDOW
    mov   	wc.lpfnWndProc, 			OFFSET WndProc 
    mov   	wc.cbClsExtra,				NULL 
    mov   	wc.cbWndExtra,				NULL 
    mov		eax,					  	hInstance 
    mov   	wc.hInstance,				eax 
    mov   	wc.hbrBackground,			COLOR_BTNFACE		+1 
    mov   	wc.lpszMenuName,			NULL 
    mov   	wc.lpszClassName,			OFFSET MainWndClassName
    INVOKE 	LoadIcon,					NULL,IDI_APPLICATION 
    mov   	wc.hIcon,					eax 
    mov   	wc.hIconSm,					eax 
    INVOKE	LoadCursor,					0,IDC_ARROW
    mov   	wc.hCursor,					eax
    ;and go register
    INVOKE 	RegisterClassEx, 			addr wc
    ;read the settings file
    INVOKE	SetFilePointer,				hFile_Settings,0,0,FILE_BEGIN 
    INVOKE	ReadFile,					hFile_Settings,pBuffer_1000h,FS_Poz_SecWin,ADDR wc,0
    mov		ecx,						pBuffer_1000h
    .IF		eax==0
		 mov   (RECT ptr [ecx+FS_Poz_MainWin]).left,100
		 mov   (RECT ptr [ecx+FS_Poz_MainWin]).top,100
		 mov   (RECT ptr [ecx+FS_Poz_MainWin]).right,500
		 mov   (RECT ptr [ecx+FS_Poz_MainWin]).bottom,350
    .endif
    ;and, finally, create the window
    INVOKE 	CreateWindowEx,		0,\
    							ADDR MainWndClassName,ADDR AppName,\ 
                				WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN,\ 
							    (RECT ptr [ecx+FS_Poz_MainWin]).left,\
							    (RECT ptr [ecx+FS_Poz_MainWin]).top,\
							    (RECT ptr [ecx+FS_Poz_MainWin]).right,\
							    (RECT ptr [ecx+FS_Poz_MainWin]).bottom,\
							    NULL,hMenuBar,hInstance,NULL 
    mov    	hWndMain,			eax
    INVOKE 	ShowWindow, 		hWndMain,SW_SHOW
    ;images (only button for now)
    INVOKE	LoadImages
ret
MainW_Create 	endp

CreateMWinComponents	proc	uses ebx
LOCAL	RecT1:RECT
	
	
					;File list
    INVOKE 	CreateWindowEx,				WS_EX_RIGHT or WS_EX_CLIENTEDGE,ADDR ClsList ,0,\ 
    									WS_HSCROLL or WS_BORDER or WS_CHILD or WS_HSCROLL	or WS_VISIBLE or WS_VSCROLL	or \
    									LBS_NOINTEGRALHEIGHT or LBS_MULTIPLESEL or LBS_HASSTRINGS or LBS_NOTIFY or LBS_SORT	or LBS_WANTKEYBOARDINPUT, 
				    	        		10,30,280,360,hWndMain,NULL,hInstance, NULL 
    mov    	hWnd_List_Gen,				eax
	
					;Edit <Real File>
    INVOKE 	CreateWindowEx,				WS_EX_RIGHT or WS_EX_OVERLAPPEDWINDOW	,ADDR ClsTextBox ,0,\ 
    									WS_CHILD or WS_VISIBLE or \
    									ES_READONLY or ES_AUTOHSCROLL, 
				    	        		340,30,280,18,hWndMain,NULL,hInstance, NULL 
    mov    	hWnd_Edit_CrtFile,			eax
	
					;Edit <Mask File>
    INVOKE 	CreateWindowEx,				WS_EX_RIGHT or WS_EX_OVERLAPPEDWINDOW	,ADDR ClsTextBox ,0,\ 
    									WS_CHILD or WS_VISIBLE or \
    									ES_READONLY or ES_AUTOHSCROLL, 
				    	        		340,100,280,18,hWndMain,NULL,hInstance, NULL 
    mov    	hWnd_Edit_MaskFile,			eax
	
	;fonts
	INVOKE	GetStockObject,				ANSI_VAR_FONT
	mov		ebx,						eax	
	INVOKE	SendMessage,				hWnd_List_Gen,WM_SETFONT,ebx,FALSE
	INVOKE	SendMessage,				hWnd_Edit_CrtFile,WM_SETFONT,ebx,FALSE
	INVOKE	SendMessage,				hWnd_Edit_MaskFile,WM_SETFONT,ebx,FALSE
	
	;Buttons
	mov		ebx,				OFFSET ButtonsProp
	
	;<Add files>
	mov		(strButPrp ptr [ebx+But_AddFiles]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_AddFiles]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_AddFiles]).Coord.left,Align_Left
	mov		(strButPrp ptr [ebx+But_AddFiles]).Text,OFFSET TBut_Add
	mov		(strButPrp ptr [ebx+But_AddFiles]).Status,StatBut_Up
	
	;<Remove files> 
	mov		(strButPrp ptr [ebx+But_DelFiles]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_DelFiles]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_DelFiles]).Coord.left,Align_Left
	mov		(strButPrp ptr [ebx+But_DelFiles]).Text,OFFSET TBut_Del
	mov		(strButPrp ptr [ebx+But_DelFiles]).Status,StatBut_Up
	
	;<Select all>
	mov		(strButPrp ptr [ebx+But_SelAll]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_SelAll]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_SelAll]).Coord.left,(Align_Left+Width_But+Dist_H_ButBut)
	mov		(strButPrp ptr [ebx+But_SelAll]).Text,OFFSET TBut_SelAll
	mov		(strButPrp ptr [ebx+But_SelAll]).Status,StatBut_Up
	
	;<Invert sel>
	mov		(strButPrp ptr [ebx+But_InvSel]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_InvSel]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_InvSel]).Coord.left,(Align_Left+Width_But+Dist_H_ButBut)
	mov		(strButPrp ptr [ebx+But_InvSel]).Text,OFFSET TBut_InvSel
	mov		(strButPrp ptr [ebx+But_InvSel]).Status,StatBut_Up
	
	;<Multiple sel>
	mov		(strButPrp ptr [ebx+But_SelMul]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_SelMul]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_SelMul]).Coord.left,(Align_Left+Width_But*2+Dist_H_ButBut*2)
	mov		(strButPrp ptr [ebx+But_SelMul]).Text,OFFSET TBut_SelMul
	mov		(strButPrp ptr [ebx+But_SelMul]).Status,StatBut_Up
	
	;<Status - Encoded>
	mov		(strButPrp ptr [ebx+But_StatEnc]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_StatEnc]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_StatEnc]).Coord.top,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames)+Dist_V_FrameButS
	mov		(strButPrp ptr [ebx+But_StatEnc]).Text,OFFSET TBut_Cod
	mov		(strButPrp ptr [ebx+But_StatEnc]).Status,StatBut_Up
	
	;<Status - Decoded>
	mov		(strButPrp ptr [ebx+But_StatDcd]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_StatDcd]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_StatDcd]).Coord.top,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames)+Dist_V_FrameButS+Dist_V_Buttons+Height_Button
	mov		(strButPrp ptr [ebx+But_StatDcd]).Text,OFFSET TBut_Dcd
	mov		(strButPrp ptr [ebx+But_StatDcd]).Status,StatBut_Up
	
	;<Add mask file>
	mov		(strButPrp ptr [ebx+But_MaskAdd]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_MaskAdd]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_MaskAdd]).Coord.top,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames)+Dist_V_FrameButS+Dist_V_Buttons+Height_Button
	mov		(strButPrp ptr [ebx+But_MaskAdd]).Text,OFFSET TBut_Add
	mov		(strButPrp ptr [ebx+But_MaskAdd]).Status,StatBut_Up
	
	;<Remove mask file>
	mov		(strButPrp ptr [ebx+But_MaskDel]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_MaskDel]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_MaskDel]).Coord.top,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames)+Dist_V_FrameButS
	mov		(strButPrp ptr [ebx+But_MaskDel]).Text,OFFSET TBut_Del
	mov		(strButPrp ptr [ebx+But_MaskDel]).Status,StatBut_Up
	
	;<Add password>
	mov		(strButPrp ptr [ebx+But_PasAdd]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_PasAdd]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_PasAdd]).Coord.top,	(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames+Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2+Dist_V_Frames+Dist_V_FrameButS)
	mov		(strButPrp ptr [ebx+But_PasAdd]).Text,OFFSET TBut_Add
	mov		(strButPrp ptr [ebx+But_PasAdd]).Status,StatBut_Up
	
	;<Remove password>
	mov		(strButPrp ptr [ebx+But_PasDel]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_PasDel]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_PasDel]).Coord.top,	(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames+Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2+Dist_V_Frames+Dist_V_FrameButS)+Height_Button+Dist_V_Buttons
	mov		(strButPrp ptr [ebx+But_PasDel]).Text,OFFSET TBut_Del
	mov		(strButPrp ptr [ebx+But_PasDel]).Status,StatBut_Up
	
	;<Enter pass in memory>
	mov		(strButPrp ptr [ebx+But_PassInM]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_PassInM]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_PassInM]).Coord.top,	(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames+Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2+Dist_V_Frames+Dist_V_FrameButS)
	mov		(strButPrp ptr [ebx+But_PassInM]).Text,OFFSET TBut_Enter
	mov		(strButPrp ptr [ebx+But_PassInM]).Status,StatBut_Up
	
	;<Remove pass from memory>
	mov		(strButPrp ptr [ebx+But_PasOutm]).Coord.right,Width_But
	mov		(strButPrp ptr [ebx+But_PasOutm]).Coord.bottom,Height_Button
	mov		(strButPrp ptr [ebx+But_PasOutm]).Coord.top,	(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames+Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2+Dist_V_Frames+Dist_V_FrameButS)+Height_Button+Dist_V_Buttons
	mov		(strButPrp ptr [ebx+But_PasOutm]).Text,OFFSET TBut_Rem
	mov		(strButPrp ptr [ebx+But_PasOutm]).Status,StatBut_Up
	
	;resize => force redraw
	INVOKE	Event__WM_SIZE
ret
CreateMWinComponents 	endp

MenuCreation	proc
LOCAL MII:MENUITEMINFO
	
	
	mov		MII.cbSize,						SIZEOF MENUITEMINFO
	mov		MII.fMask,						MIIM_CHECKMARKS or MIIM_DATA or MIIM_ID or MIIM_STATE or MIIM_SUBMENU or MIIM_TYPE
	mov		MII.fType,						MFT_STRING
	mov		MII.fState,						MFS_ENABLED
	mov		MII.hbmpChecked,				0
	mov		MII.hbmpUnchecked,				0
	mov		MII.dwItemData,					0
	;PopUp menu _Project_
	INVOKE	CreatePopupMenu
	mov		hPopUp_Project,					eax
	;PopUp menu _Help_
	INVOKE	CreatePopupMenu
	mov		hPopUp_Help,					eax
	
	;Menu bar
	INVOKE	CreateMenu
	mov		hMenuBar,					eax
	
	
		;	MENUS IN THE MENU BAR
	;Project
	mov		MII.wID,						ID_M_Project
	mov		eax,							hPopUp_Project
	mov		MII.hSubMenu,					eax
	mov		MII.dwTypeData,					OFFSET TextMen_Prj
	mov		MII.cch,						7	
	INVOKE	InsertMenuItem,					hMenuBar,0,TRUE,ADDR MII
	;Help
	mov		MII.wID,						ID_M_Help
	mov		eax,							hPopUp_Help
	mov		MII.hSubMenu,					eax
	mov		MII.dwTypeData,					OFFSET TextMen_Help
	mov		MII.cch,						6	
	INVOKE	InsertMenuItem,					hMenuBar,1,TRUE,ADDR MII
	
	
	
	mov		MII.hSubMenu,					0

		;	MENUS IN THE _PROJECT_ MENU
	;Project -> New
	mov		MII.wID,						ID_M_NewPrj
	mov		MII.dwTypeData,					OFFSET TextMen_NewPrj
	mov		MII.cch,						10	
	INVOKE	InsertMenuItem,					hPopUp_Project,0,TRUE,ADDR MII

	;Project -> Open ...
	mov		MII.wID,						ID_M_OpenPrj
	mov		MII.dwTypeData,					OFFSET TextMen_OpenPrj
	mov		MII.cch,						21	
	INVOKE	InsertMenuItem,					hPopUp_Project,1,TRUE,ADDR MII

	;Project -> Close
	mov		MII.wID,						ID_M_ClosePrj
	mov		MII.dwTypeData,					OFFSET TextMen_ClosePrj
	mov		MII.cch,						16	
	INVOKE	InsertMenuItem,					hPopUp_Project,2,TRUE,ADDR MII
	
	;Project -> Save 
	mov		MII.wID,						ID_M_Save
	mov		MII.dwTypeData,					OFFSET TextMen_Save
	mov		MII.cch,						7	
	INVOKE	InsertMenuItem,					hPopUp_Project,4,TRUE,ADDR MII
	
	;Project -> Save as ...
	mov		MII.wID,						ID_M_SaveAs
	mov		MII.dwTypeData,					OFFSET TextMen_SaveAs
	mov		MII.cch,						14	
	INVOKE	InsertMenuItem,					hPopUp_Project,5,TRUE,ADDR MII
	
	;Project -> Exit
	mov		MII.wID,						ID_M_ExitProg
	mov		MII.dwTypeData,					OFFSET TextMen_ExitProg
	mov		MII.cch,						14	
	INVOKE	InsertMenuItem,					hPopUp_Project,7,TRUE,ADDR MII
	
	
		;	MENUS IN THE _HELP_ MENU
	;Help -> Content
	mov		MII.wID,						ID_M_Help_Cont
	mov		MII.dwTypeData,					OFFSET TextMen_Help_Contin
	mov		MII.cch,						14	
	INVOKE	InsertMenuItem,					hPopUp_Help,0,TRUE,ADDR MII
	;Help -> About
	mov		MII.wID,						ID_M_Help_About
	mov		MII.dwTypeData,					OFFSET TextMen_Help_About
	mov		MII.cch,						14	
	INVOKE	InsertMenuItem,					hPopUp_Help,1,TRUE,ADDR MII


		;Horizontal Lines
	mov		MII.wID,						ID_M_Line
	mov		MII.hSubMenu,					0
	mov		MII.dwTypeData,					0
	mov		MII.cch,						0
	mov		MII.fType,						MFT_SEPARATOR
	INVOKE	InsertMenuItem,					hPopUp_Project,3,TRUE,ADDR MII	
	INVOKE	InsertMenuItem,					hPopUp_Project,6,TRUE,ADDR MII	
	INVOKE	InsertMenuItem,					hPopUp_Help,1,TRUE,ADDR MII	
	
	;INVOKE	SetMenu,						hWndMain,hMenuBar
ret
MenuCreation endp
	
WndProc proc uses esi hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
	mov		eax,			hWnd
	cmp		eax,			hWndMain
	jne		LBL_UnProcessed
;
		___WM_CLOSE:
		cmp		uMsg,			WM_CLOSE
			jne		___WM_DESTROY
			INVOKE	ClosePrj
			INVOKE	FS_SaveAtTheEnd
			INVOKE	DestroyWindow,	hWndMain
			jmp		LBL_Processed
;			
		___WM_DESTROY:
		cmp		uMsg,			WM_DESTROY
		jne		___WM_SIZE
			INVOKE	PostQuitMessage, 	NULL
			jmp		LBL_Processed
;
		___WM_SIZE:
		cmp		uMsg,			WM_SIZE
		jne		___WM_PAINT
			INVOKE	Event__WM_SIZE
			jmp		LBL_Processed
;
		___WM_PAINT:
		cmp		uMsg,			WM_PAINT
		jne		___WM_LBUTTONDOWN
			INVOKE	Event__WM_PAINT
			jmp		LBL_Processed
;
		___WM_LBUTTONDOWN:
		cmp		uMsg,			WM_LBUTTONDOWN
		jne		___WM_LBUTTONUP
			INVOKE	Event__WM_LBUTTONDOWN,wParam,lParam
			jmp		LBL_Processed
;
		___WM_LBUTTONUP:
		cmp		uMsg,			WM_LBUTTONUP
		jne		___WM_COMMAND
			INVOKE	Event__WM_LBUTTONUP,wParam,lParam
			jmp		LBL_Processed
;
		___WM_COMMAND:
		cmp		uMsg,			WM_COMMAND
		jne		LBL_UnProcessed
			mov		eax,				lParam
			mov		ecx,				wParam
			;			MENUES
			.IF		cx==ID_M_NewPrj
				INVOKE	OpenNewPrj
			.ELSEIF	cx==ID_M_OpenPrj
				INVOKE	OpenPrj
			.ELSEIF	cx==ID_M_ClosePrj
				INVOKE	ClosePrj
			.ELSEIF	cx==ID_M_SaveAs
				INVOKE	SavePrjAs
			.ELSEIF	cx==ID_M_ExitProg
				INVOKE	SendMessage,	hWndMain,WM_CLOSE,0,0
			.ELSEIF	cx==ID_M_Save
				INVOKE	SavePrjToDisk
			.ELSEIF	cx==ID_M_Help_Cont
				
			.ELSEIF	cx==ID_M_Help_About
				
			;			LIST
			.ELSEIF	eax==hWnd_List_Gen
				rol		ecx,				16
				cmp		cx,					LBN_SELCHANGE
				jne		LBL_UnProcessed
					mov		eax,				OFFSET ButtonsProp
					cmp (strButPrp ptr [eax+But_SelMul]).Status, StatBut_Up
					jne	@F
						INVOKE	SendMessage,		hWnd_List_Gen,LB_SETSEL,FALSE,-1
						INVOKE	SendMessage,		hWnd_List_Gen,LB_GETCARETINDEX,0,0
						INVOKE	SendMessage,		hWnd_List_Gen,LB_SETSEL,TRUE,eax
					@@:
					INVOKE	ShowInterface,	ShowType_InfoSel
			.ELSE
				jmp		LBL_UnProcessed
			.ENDIF
			jmp		LBL_Processed
;			
			
			
			
LBL_UnProcessed:
INVOKE 	DefWindowProc,		hWnd,uMsg,wParam,lParam     
ret
LBL_Processed:
xor eax,eax
ret
WndProc	endp

Message_Loop	proc
LOCAL msg:MSG 
	
    .WHILE TRUE                                                        
        INVOKE 	GetMessage, 					ADDR msg,NULL,0,0 
        .BREAK 	.IF (!eax) 
        .IF		msg.message==WM_MOUSEMOVE
        	INVOKE	ShowInfos,msg.lParam,msg.hwnd
        .ENDIF
        INVOKE 	TranslateMessage, 				ADDR msg 
        INVOKE 	DispatchMessage, 				ADDR msg 
   .ENDW 
    mov     eax,							msg.wParam   	
ret
Message_Loop endp

Event__WM_PAINT			proc
LOCAL	PS		:PAINTSTRUCT
	
	INVOKE	BeginPaint,		hWndMain,ADDR PS
	INVOKE	BitBlt,			PS.hdc,PS.rcPaint.left,PS.rcPaint.top,PS.rcPaint.right,PS.rcPaint.bottom,hDCBuffMain,PS.rcPaint.left,PS.rcPaint.top,SRCCOPY
	INVOKE	EndPaint,		hWndMain,ADDR PS		
ret
Event__WM_PAINT 		endp

Event__WM_SIZE			proc	uses ebx
;What will be if we resize the window? THIS
LOCAL	VarDW1		:DWORD
LOCAL	VarDW2		:DWORD
LOCAL	RecT1		:RECT	
LOCAL	RecT2		:RECT


	INVOKE	GetClientRect,		hWndMain,addr RecT1
	.IF		RecT1.right<0245h
		mov		RecT1.right,		0245h
	.endif
	.IF		RecT1.bottom<018Dh
		mov		RecT1.bottom,		018Dh
	.endif
	
	mov		ebx,				OFFSET ButtonsProp
	INVOKE	GetStockObject,		NULL_PEN
	INVOKE	SelectObject,		hDCBuffMain,eax
	INVOKE	SelectObject,		hDCBuffMain,hBrs_BackMain
	INVOKE	Rectangle,			hDCBuffMain,RecT1.left,RecT1.top,RecT1.right,RecT1.bottom
	
	
	;Label for the list
	INVOKE	SelectObject,		hDCBuffMain,hFnt_Labels
	INVOKE	SetTextColor,		hDCBuffMain,LabelTxtColor
	INVOKE	TextOut,			hDCBuffMain,Align_Left,Align_Up,ADDR Title_Files,5

	;add files button
	;rem files button
	;sel all button
	;inv sel button
	;sel mul button
	mov		eax,				RecT1.bottom
	sub		eax,				(Align_Down+Height_Button)
	mov		(strButPrp ptr [ebx+But_DelFiles]).Coord.top,eax
	mov		(strButPrp ptr [ebx+But_InvSel]).Coord.top,eax
	mov		(strButPrp ptr [ebx+But_SelMul]).Coord.top,eax
	sub		eax,				(Dist_V_Buttons+Height_Button)
	mov		(strButPrp ptr [ebx+But_AddFiles]).Coord.top,eax
	mov		(strButPrp ptr [ebx+But_SelAll]).Coord.top,eax
	
	;vertical line
	INVOKE	GetStockObject,		WHITE_PEN
	INVOKE	SelectObject,		hDCBuffMain,eax
	mov		eax,				RecT1.right
	shr		eax,				1
	mov		VarDW1,				eax
	INVOKE	MoveToEx,			hDCBuffMain,eax,Align_Up,0
	mov		eax,				RecT1.bottom
	sub		eax,				Align_Down
	mov		VarDW2,				eax
	INVOKE	LineTo,				hDCBuffMain,VarDW1,eax
	inc		VarDW1
	
	INVOKE	SelectObject,		hDCBuffMain,hPen_Grey0C_1
	INVOKE	MoveToEx,			hDCBuffMain,VarDW1,Align_Up,0
	INVOKE	LineTo,				hDCBuffMain,VarDW1,VarDW2
		
	;files list
	mov		eax,				VarDW1
	sub		eax,				(Aliniam_Mid+Align_Left)
	mov		ecx,				RecT1.bottom
	sub		ecx,				(Align_Down+Height_Button*2+Dist_V_Buttons+Dist_V_List_But+Align_Up+Dist_V_Text_Item)
	INVOKE	MoveWindow,			hWnd_List_Gen,Align_Left,(Align_Up+Dist_V_Text_Item),\
								eax,ecx,TRUE
	
	;label for real and mask file
	add		VarDW1,				Aliniam_Mid
	INVOKE	SelectObject,		hDCBuffMain,hFnt_Labels
	INVOKE	SetTextColor,		hDCBuffMain,LabelTxtColor
	INVOKE	TextOut,			hDCBuffMain,VarDW1,Align_Up,ADDR Title_RealF,9
	INVOKE	TextOut,			hDCBuffMain,VarDW1,(Align_Up+Dist_V_Edit),ADDR Title_MaskF,9
	mov		eax,				RecT1.right
	sub		eax,				VarDW1
	sub		eax,				Align_Right
	mov		VarDW2,				eax
	INVOKE	MoveWindow,			hWnd_Edit_CrtFile,VarDW1,(Align_Up+Dist_V_Text_Item),\
								eax,Height_Edit,TRUE
	INVOKE	MoveWindow,			hWnd_Edit_MaskFile,VarDW1,(Align_Up+Dist_V_Text_Item+Dist_V_Edit),\
								VarDW2,Height_Edit,TRUE
	
	;first horizontal line
	INVOKE	SelectObject,		hDCBuffMain,hPen_Grey0C_1
	mov		eax,				VarDW1
	add		VarDW2,				eax
	INVOKE	MoveToEx,			hDCBuffMain,VarDW1,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2),0
	INVOKE	LineTo,				hDCBuffMain,VarDW2,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2)
	INVOKE	GetStockObject,		WHITE_PEN
	INVOKE	SelectObject,		hDCBuffMain,eax
	INVOKE	MoveToEx,			hDCBuffMain,VarDW1,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2)+1,0
	INVOKE	LineTo,				hDCBuffMain,VarDW2,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2)+1
	
	
	;status frame
	mov		eax,				VarDW1
	mov		RecT2.left,		eax
	mov		(strButPrp ptr [ebx+But_StatEnc]).Coord.left,eax
	mov		(strButPrp ptr [ebx+But_StatDcd]).Coord.left,eax
	mov		(strButPrp ptr [ebx+But_PasAdd]).Coord.left,eax
	mov		(strButPrp ptr [ebx+But_PasDel]).Coord.left,eax
	add		(strButPrp ptr [ebx+But_StatEnc]).Coord.left,Dist_H_FrameButS
	add		(strButPrp ptr [ebx+But_StatDcd]).Coord.left,Dist_H_FrameButS
	add		(strButPrp ptr [ebx+But_PasAdd]).Coord.left,Dist_H_FrameButS
	add		(strButPrp ptr [ebx+But_PasDel]).Coord.left,Dist_H_FrameButS
	add		eax,				(Dist_H_FrameButS+Width_But+Dist_H_FrameButD)
	mov		RecT2.right,		eax
	mov		RecT2.top,			(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames)
	mov		RecT2.bottom,		(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames)+(Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2)
	INVOKE	DrawFrame,		hDCBuffMain,ADDR RecT2,ADDR Title_Status,FALSE
	
	;mask frame
	add		RecT2.left,		(Dist_H_FrameButS+Width_But+Dist_H_FrameButD)+Dist_H_Frames
	add		RecT2.right,		(Dist_H_FrameButS+Width_But+Dist_H_FrameButD)+Dist_H_Frames
	INVOKE	DrawFrame,		hDCBuffMain,ADDR RecT2,ADDR Title_Mask,FALSE
		;buttons
		mov		eax,			RecT2.left
		add		eax,			Dist_H_FrameButS
		mov		(strButPrp ptr [ebx+But_MaskAdd]).Coord.left,eax
		mov		(strButPrp ptr [ebx+But_MaskDel]).Coord.left,eax
		mov		(strButPrp ptr [ebx+But_PassInM]).Coord.left,eax
		mov		(strButPrp ptr [ebx+But_PasOutm]).Coord.left,eax
	
	;pass farame
	mov		eax,				VarDW1
	mov		RecT2.left,		eax
	add		RecT2.top,			(Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2)+Dist_V_Frames
	add		RecT2.bottom,		(Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2)+Dist_V_Frames
	
	INVOKE	DrawFrame,		hDCBuffMain,ADDR RecT2,ADDR Title_Pass,FALSE
	
	;second horizontal line
	INVOKE	SelectObject,		hDCBuffMain,hPen_Grey0C_1
	INVOKE	MoveToEx,			hDCBuffMain,VarDW1,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames+Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2+Dist_V_Frames+Dist_V_FrameButS)+Height_Button*2+Dist_V_Buttons+Dist_V_FrameButJ+Dist_V_Frames,0
	INVOKE	LineTo,				hDCBuffMain,VarDW2,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames+Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2+Dist_V_Frames+Dist_V_FrameButS)+Height_Button*2+Dist_V_Buttons+Dist_V_FrameButJ+Dist_V_Frames
	INVOKE	GetStockObject,		WHITE_PEN
	INVOKE	SelectObject,		hDCBuffMain,eax
	INVOKE	MoveToEx,			hDCBuffMain,VarDW1,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames+Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2+Dist_V_Frames+Dist_V_FrameButS)+Height_Button*2+Dist_V_Buttons+Dist_V_FrameButJ+Dist_V_Frames+1,0
	INVOKE	LineTo,				hDCBuffMain,VarDW2,(Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames+Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2+Dist_V_Frames+Dist_V_FrameButS)+Height_Button*2+Dist_V_Buttons+Dist_V_FrameButJ+Dist_V_Frames+1

	;Infos
	INVOKE	SelectObject,		hDCBuffMain,hPen_Grey0C_1

	mov		eax,				((Align_Up+Dist_V_Text_Item+Dist_V_Edit*2+Dist_V_Frames+Dist_V_FrameButS+Dist_V_Buttons+Dist_V_FrameButJ+Height_Button*2+Dist_V_Frames+Dist_V_FrameButS)+Height_Button*2+Dist_V_Buttons+Dist_V_FrameButJ+Dist_V_Frames)+Dist_V_InfoZ
	mov		ecx,				RecT1.bottom
	sub		ecx,				Align_Down
	mov		edx,				VarDW2
	INVOKE	Rectangle,			hDCBuffMain,VarDW1,eax,edx,ecx
	
	;draw the buttons
	;replace this with a loop
	INVOKE	DrawButton,		hDCBuffMain,But_AddFiles,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_DelFiles,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_SelAll,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_InvSel,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_SelMul,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_StatEnc,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_StatDcd,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_MaskAdd,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_MaskDel,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_PasAdd,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_PasDel,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_PassInM,FALSE
	INVOKE	DrawButton,		hDCBuffMain,But_PasOutm,FALSE
	
	INVOKE	ShowInfos,		0,-1
	INVOKE	InvalidateRect,hWndMain,0,TRUE
	INVOKE	InvalidateRect,hWnd_List_Gen,0,TRUE
ret
Event__WM_SIZE endp

Event__WM_LBUTTONDOWN	proc	uses esi Flags_Loc:DWORD,Position:DWORD
	INVOKE	SetCapture,		hWndMain
	INVOKE	HitTestBut,		Position
	.IF		eax!=-1
		;preserve the status
		mov		eax,			esi
		add		eax,			OFFSET ButtonsProp
		cmp		(strButPrp ptr [eax]).Enabled,	Enabled_FALSE
		je		NoButton
		mov		dl,				(strButPrp ptr [eax]).Status
		mov		ButtonStat,		dl
		mov		ButtonIdx,		esi
		mov		(strButPrp ptr [eax]).Status,		StatBut_Down
		jmp		ShowButt
		.IF		esi==But_AddFiles
			mov		(strButPrp ptr [eax]).Status,		StatBut_Down
			jmp		ShowButt
		.ELSEIF esi==But_DelFiles
			mov		(strButPrp ptr [eax]).Status,		StatBut_Down
			jmp		ShowButt
		.ELSEIF esi==But_SelAll
			mov		(strButPrp ptr [eax]).Status,		StatBut_Down
			jmp		ShowButt
		.ELSEIF esi==But_InvSel
			mov		(strButPrp ptr [eax]).Status,		StatBut_Down
			jmp		ShowButt
		.ELSEIF esi==But_SelMul
			.IF		ButtonStat==StatBut_Up
				mov		(strButPrp ptr [eax]).Status,		StatBut_Down
				jmp		ShowButt
			.ENDIF
;		.ELSEIF esi==But_StatEnc
;			
;		.ELSEIF esi==But_StatDcd
;			
;		.ELSEIF esi==But_MaskAdd
;			
;		.ELSEIF esi==But_MaskDel
;			
;		.ELSEIF esi==But_PasAdd
;			
;		.ELSEIF esi==But_PasDel
;			
;		.ELSEIF esi==But_PassInM
;			
;		.ELSEIF esi==But_PasOutm
			
		.ENDIF
	.ELSE
	NoButton:
		mov		ButtonIdx,		-1
	.ENDIF
	
RET
ShowButt:
INVOKE	DrawButton,	hDCBuffMain,ButtonIdx,TRUE
ret
Event__WM_LBUTTONDOWN	ENDP

Event__WM_LBUTTONUP		proc	uses esi Flags_Loc:DWORD,Position:DWORD
	
	INVOKE	ReleaseCapture
	INVOKE	HitTestBut,		Position
	.IF		esi==ButtonIdx
		mov		eax,		esi
		add		eax,		OFFSET ButtonsProp 
		.IF		esi==But_AddFiles
			INVOKE	AddFilesToPrj
			jmp		Restabilire
		.ELSEIF esi==But_DelFiles
			INVOKE	RemFilesFromPrj
			jmp		Restabilire
		.ELSEIF esi==But_SelAll
			INVOKE	SendMessage,hWnd_List_Gen,LB_GETCOUNT,0,0
			mov		Flags_Loc,	eax
			.WHILE	Flags_Loc>0
				dec		Flags_Loc
				INVOKE	SendMessage,hWnd_List_Gen,LB_SETSEL,TRUE,Flags_Loc
			.ENDW
			INVOKE	ShowInterface,	ShowType_InfoSel
			jmp		Restabilire
		.ELSEIF esi==But_InvSel
			INVOKE	SendMessage,hWnd_List_Gen,LB_GETCOUNT,0,0
			mov		Flags_Loc,	eax
			.WHILE	Flags_Loc>0
				dec		Flags_Loc
				INVOKE	SendMessage,hWnd_List_Gen,LB_GETSEL,Flags_Loc,0
				.IF		eax==0
					mov	eax, TRUE
				.ELSE
					mov	eax, FALSE
				.ENDIF
				INVOKE	SendMessage,hWnd_List_Gen,LB_SETSEL,eax,Flags_Loc
			.ENDW
			INVOKE	ShowInterface,	ShowType_InfoSel
			jmp		Restabilire
		.ELSEIF esi==But_SelMul
			mov		ecx,				OFFSET ButtonsProp
			.IF		ButtonStat==StatBut_Up
				mov		(strButPrp ptr [eax]).Status,		StatBut_Down
				mov		(strButPrp ptr [ecx+But_InvSel]).Enabled,Enabled_TRUE
				mov		(strButPrp ptr [ecx+But_SelAll]).Enabled,Enabled_TRUE
			.ELSE
				mov		(strButPrp ptr [eax]).Status,		StatBut_Up
				mov		(strButPrp ptr [ecx+But_InvSel]).Enabled,Enabled_FALSE
				mov		(strButPrp ptr [ecx+But_SelAll]).Enabled,Enabled_FALSE
				INVOKE	SendMessage,		hWnd_List_Gen,LB_GETSELCOUNT,0,0
				.IF		eax>1
					INVOKE	SendMessage,		hWnd_List_Gen,LB_SETSEL,FALSE,-1
					INVOKE	SendMessage,		hWnd_List_Gen,LB_SETSEL,TRUE,0
					INVOKE	ShowInterface,	ShowType_InfoSel
				.ENDIF
			.ENDIF
			INVOKE	DrawButton,		hDCBuffMain,But_InvSel,TRUE
			INVOKE	DrawButton,		hDCBuffMain,But_SelAll,TRUE
			jmp		Afisare
		.ELSEIF esi==But_StatEnc
			.IF		ButtonStat==StatBut_Up
				mov		MySemaphore_1,		Semaph_Green
				mov		eax,			OFFSET EncodeSelection
				INVOKE	CreateThread,	0,0,eax,0,0,ADDR IDTH_EncdDecd
				INVOKE	FeedBack_Proc
			.ENDIF
		.ELSEIF esi==But_StatDcd
			.IF		ButtonStat==StatBut_Up
				mov		MySemaphore_1,		Semaph_Green
				mov		eax,			OFFSET DecodeSelection
				INVOKE	CreateThread,	0,0,eax,0,0,ADDR IDTH_EncdDecd
				INVOKE	FeedBack_Proc
			.ENDIF
		.ELSEIF esi==But_MaskAdd
			.IF		ButtonStat==StatBut_Up
				INVOKE	AddMask
			.ENDIF
		.ELSEIF esi==But_MaskDel
			.IF		ButtonStat==StatBut_Up
				INVOKE	DeleteMask
			.ENDIF
		.ELSEIF esi==But_PasAdd
			.IF		ButtonStat==StatBut_Up
				INVOKE	PasswWork,	AddPassType_File_Add
			.ENDIF
		.ELSEIF esi==But_PasDel
			.IF		ButtonStat==StatBut_Up
				INVOKE	DeletePass,	DelType_FromPrj
			.ENDIF
		.ELSEIF esi==But_PassInM
			.IF		ButtonStat==StatBut_Up
				INVOKE	PasswWork,	AddPassType_File_Enter
			.ENDIF
		.ELSEIF esi==But_PasOutm
			.IF		ButtonStat==StatBut_Up
				INVOKE	DeletePass,	DelType_FromMem
			.ENDIF
		.ENDIF
	.ELSEIF		ButtonIdx!=-1
		mov		esi,			ButtonIdx
		Restabilire:
		add		esi,			OFFSET ButtonsProp
		mov		dl,				ButtonStat
		mov		(strButPrp ptr [esi]).Status,		dl
		Afisare:
		INVOKE	DrawButton,	hDCBuffMain,ButtonIdx,TRUE
	.ENDIF
	mov		ButtonIdx,			-1
RET
Event__WM_LBUTTONUP	endp

HitTestBut					proc	Position:DWORD
;if the mouse is over a button, this will tell us wich one
LOCAL	PositionRight		:DWORD
LOCAL	PositionUp			:DWORD

	xor		ecx,			ecx
	mov		eax,			Position
	mov		cx,				ax
	shr		eax,			16
	mov		PositionUp,			eax
	mov		PositionRight,		ecx
	
	
	mov		esi,			OFFSET ButtonsProp
	sub		esi,			SIZEOF strButPrp
	mov		edx,			-1
	
	NextPlease:
	add		esi,			SIZEOF strButPrp
	mov		eax,			-1
	inc		edx
	cmp		edx,			ButtonsCount
	jae		GetOutOfHere
	mov		eax,			(strButPrp ptr [esi]).Coord.left
	mov		ecx,			(strButPrp ptr [esi]).Coord.top
	cmp		PositionRight,eax
	jb		NextPlease
	cmp		PositionUp,ecx
	jb		NextPlease
	add		eax,			(strButPrp ptr [esi]).Coord.right
	add		ecx,			(strButPrp ptr [esi]).Coord.bottom
	cmp		PositionRight,eax
	ja		NextPlease
	cmp		PositionUp,ecx
	ja		NextPlease
		mov		eax,			PositionRight
		mov		ecx,			PositionUp
		sub		esi,			OFFSET ButtonsProp
	GetOutOfHere:
ret
HitTestBut endp

ShowInterface			proc	uses ebx esi ShowType:DWORD
LOCAL	VarDW1		:DWORD
LOCAL	VarDW2		:DWORD
	
	
	.IF		ShowType==ShowType_NoPrj
		INVOKE	SendMessage,	hWnd_List_Gen,LB_RESETCONTENT,0,0
		INVOKE	SendMessage,	hWnd_Edit_CrtFile,WM_SETTEXT,0,0
		INVOKE	SendMessage,	hWnd_Edit_MaskFile,WM_SETTEXT,0,0
		
		INVOKE	EnableMenuItem,hPopUp_Project,ID_M_ClosePrj,MF_GRAYED OR MF_BYCOMMAND		
		INVOKE	EnableMenuItem,hPopUp_Project,ID_M_SaveAs,MF_GRAYED OR MF_BYCOMMAND
		INVOKE	EnableMenuItem,hPopUp_Project,ID_M_Save,MF_GRAYED OR MF_BYCOMMAND
		
		
		INVOKE	EnableWindow,	hWnd_List_Gen,FALSE
		INVOKE	EnableWindow,	hWnd_Edit_CrtFile,FALSE
		INVOKE	EnableWindow,	hWnd_Edit_MaskFile,FALSE
		mov		VarDW1,			0
		.WHILE	VarDW1<(ButtonsCount*SIZEOF strButPrp)
			mov		eax,		VarDW1
			add		eax,		OFFSET ButtonsProp
			mov		(strButPrp ptr [eax]).Enabled,	Enabled_FALSE
			INVOKE	DrawButton,	hDCBuffMain,VarDW1,FALSE
			add		VarDW1,		SIZEOF strButPrp
		.ENDW
		
		INVOKE	InvalidateRect,	hWndMain,0,FALSE
	.ELSEIF	ShowType==ShowType_WithPrj
		INVOKE	EnableMenuItem,hPopUp_Project,ID_M_ClosePrj,MF_ENABLED OR MF_BYCOMMAND		
		INVOKE	EnableMenuItem,hPopUp_Project,ID_M_SaveAs,MF_ENABLED OR MF_BYCOMMAND
		INVOKE	EnableMenuItem,hPopUp_Project,ID_M_Save,MF_ENABLED OR MF_BYCOMMAND

		INVOKE	EnableWindow,	hWnd_List_Gen,TRUE
		INVOKE	EnableWindow,	hWnd_Edit_CrtFile,TRUE
		INVOKE	EnableWindow,	hWnd_Edit_MaskFile,TRUE
		mov		ebx,			OFFSET ButtonsProp
		mov		(strButPrp ptr [ebx+But_AddFiles]).Enabled,	Enabled_TRUE
		mov		(strButPrp ptr [ebx+But_SelAll]).Enabled,	Enabled_TRUE
		mov		(strButPrp ptr [ebx+But_InvSel]).Enabled,	Enabled_TRUE
		mov		(strButPrp ptr [ebx+But_SelMul]).Enabled,	Enabled_TRUE
		mov		(strButPrp ptr [ebx+But_SelMul]).Status,	StatBut_Down
		INVOKE	DrawButton,	hDCBuffMain,But_AddFiles,FALSE
		INVOKE	DrawButton,	hDCBuffMain,But_SelAll,FALSE
		INVOKE	DrawButton,	hDCBuffMain,But_InvSel,FALSE
		INVOKE	DrawButton,	hDCBuffMain,But_SelMul,FALSE
		INVOKE	InvalidateRect,	hWndMain,0,FALSE
		jmp		Selectie
	.ELSEIF	ShowType==ShowType_InfoSel
		Selectie:
		INVOKE	SendMessage,	hWnd_List_Gen,LB_GETCOUNT,0,0
		mov		VarDW2,			eax
		INVOKE	SendMessage,	hWnd_List_Gen,LB_GETSELCOUNT,0,0
		mov		VarDW1,			eax
		mov		ebx,			OFFSET ButtonsProp
		
		.IF		eax==0
			mov		(strButPrp ptr [ebx+But_DelFiles]).Enabled,		Enabled_FALSE
			mov		(strButPrp ptr [ebx+But_StatEnc]).Enabled,	Enabled_FALSE
			mov		(strButPrp ptr [ebx+But_StatDcd]).Enabled,	Enabled_FALSE
			mov		(strButPrp ptr [ebx+But_MaskAdd]).Enabled,	Enabled_FALSE
			mov		(strButPrp ptr [ebx+But_MaskDel]).Enabled,	Enabled_FALSE
			mov		(strButPrp ptr [ebx+But_PasAdd]).Enabled,		Enabled_FALSE
			mov		(strButPrp ptr [ebx+But_PasDel]).Enabled,		Enabled_FALSE
			mov		(strButPrp ptr [ebx+But_PassInM]).Enabled,	Enabled_FALSE
			mov		(strButPrp ptr [ebx+But_PasOutm]).Enabled,	Enabled_FALSE
			
			INVOKE	SendMessage,		hWnd_Edit_CrtFile,WM_SETTEXT,0,ADDR Str_NoFileSel
			INVOKE	SendMessage,		hWnd_Edit_MaskFile,WM_SETTEXT,0,ADDR Str_NoFileSel
		.ELSE
			mov		(strButPrp ptr [ebx+But_DelFiles]).Enabled,		Enabled_TRUE
			mov		(strButPrp ptr [ebx+But_StatEnc]).Enabled,	Enabled_TRUE
			mov		(strButPrp ptr [ebx+But_StatDcd]).Enabled,	Enabled_TRUE
			mov		(strButPrp ptr [ebx+But_MaskAdd]).Enabled,	Enabled_TRUE
			mov		(strButPrp ptr [ebx+But_MaskDel]).Enabled,	Enabled_TRUE
			;simple selection
			.IF	eax==1
				.WHILE	VarDW2>0
					dec		VarDW2
					INVOKE	SendMessage,		hWnd_List_Gen,LB_GETSEL,VarDW2,0
					.IF		eax!=0
						INVOKE	SendMessage,		hWnd_List_Gen,LB_GETTEXT,VarDW2,pBuffer_1000h
						INVOKE	SendMessage,		hWnd_Edit_CrtFile,WM_SETTEXT,0,pBuffer_1000h
						INVOKE	SendMessage,		hWnd_List_Gen,LB_GETITEMDATA,VarDW2,0
						;status
						.IF		byte ptr [eax+Ptr_MExtra_Status]==MExtra_Status_Encoded
							mov		(strButPrp ptr [ebx+But_StatEnc]).Status,		StatBut_Down
							mov		(strButPrp ptr [ebx+But_StatDcd]).Status,		StatBut_Up
							mov		(strButPrp ptr [ebx+But_MaskAdd]).Enabled,	Enabled_FALSE
							mov		(strButPrp ptr [ebx+But_MaskDel]).Enabled,	Enabled_FALSE
							mov		(strButPrp ptr [ebx+But_PasAdd]).Enabled,		Enabled_FALSE
							mov		(strButPrp ptr [ebx+But_PasDel]).Enabled,		Enabled_FALSE
							
							.IF		dword ptr [eax+Ptr_MExtra_Pass]==MExtra_Pass_Without
								mov		(strButPrp ptr [ebx+But_PassInM]).Enabled,	Enabled_FALSE
								mov		(strButPrp ptr [ebx+But_PasOutm]).Enabled,	Enabled_FALSE	
							.ELSE
								mov		(strButPrp ptr [ebx+But_PassInM]).Enabled,	Enabled_TRUE
								mov		(strButPrp ptr [ebx+But_PasOutm]).Enabled,	Enabled_TRUE
								.IF	dword ptr [eax+Ptr_MExtra_Pass]==MExtra_Pass_NotInM
									mov		(strButPrp ptr [ebx+But_PassInM]).Status,		StatBut_Up
									mov		(strButPrp ptr [ebx+But_PasOutm]).Status,		StatBut_Down
								.ELSE
									mov		(strButPrp ptr [ebx+But_PassInM]).Status,		StatBut_Down
									mov		(strButPrp ptr [ebx+But_PasOutm]).Status,		StatBut_Up
								.ENDIF
							.ENDIF
						.ELSE
							mov		(strButPrp ptr [ebx+But_StatEnc]).Status,		StatBut_Up
							mov		(strButPrp ptr [ebx+But_StatDcd]).Status,		StatBut_Down
							mov		(strButPrp ptr [ebx+But_MaskAdd]).Enabled,	Enabled_TRUE
							mov		(strButPrp ptr [ebx+But_MaskDel]).Enabled,	Enabled_TRUE
							mov		(strButPrp ptr [ebx+But_PasAdd]).Enabled,		Enabled_TRUE
							mov		(strButPrp ptr [ebx+But_PasDel]).Enabled,		Enabled_TRUE
							.IF		dword ptr [eax+Ptr_MExtra_Pass]==MExtra_Pass_Without
								mov		(strButPrp ptr [ebx+But_PassInM]).Enabled,	Enabled_FALSE
								mov		(strButPrp ptr [ebx+But_PasOutm]).Enabled,	Enabled_FALSE
								mov		(strButPrp ptr [ebx+But_PasAdd]).Status,		StatBut_Up
								mov		(strButPrp ptr [ebx+But_PasDel]).Status,		StatBut_Down
							.ELSE
								mov		(strButPrp ptr [ebx+But_PassInM]).Enabled,	Enabled_TRUE
								mov		(strButPrp ptr [ebx+But_PasOutm]).Enabled,	Enabled_TRUE
								mov		(strButPrp ptr [ebx+But_PasAdd]).Status,		StatBut_Down
								mov		(strButPrp ptr [ebx+But_PasDel]).Status,		StatBut_Up
								.IF		dword ptr [eax+Ptr_MExtra_Pass]==MExtra_Pass_NotInM
									mov		(strButPrp ptr [ebx+But_PasOutm]).Status,		StatBut_Down
									mov		(strButPrp ptr [ebx+But_PassInM]).Status,		StatBut_Up
								.ELSE
									mov		(strButPrp ptr [ebx+But_PasOutm]).Status,		StatBut_Up
									mov		(strButPrp ptr [ebx+But_PassInM]).Status,		StatBut_Down
								.endif
							.endif
						.ENDIF
						
						;mask file
						.IF		word ptr [eax+Ptr_MExtra_DimMaskName]!=0
							add		eax,				Ptr_MExtra_MaskName
							INVOKE	SendMessage,		hWnd_Edit_MaskFile,WM_SETTEXT,0,eax
							mov		(strButPrp ptr [ebx+But_MaskAdd]).Status,	StatBut_Down
							mov		(strButPrp ptr [ebx+But_MaskDel]).Status,	StatBut_Up
						.ELSE
							INVOKE	SendMessage,		hWnd_Edit_MaskFile,WM_SETTEXT,0,ADDR NoMaskName
							mov		(strButPrp ptr [ebx+But_MaskAdd]).Status,	StatBut_Up
							mov		(strButPrp ptr [ebx+But_MaskDel]).Status,	StatBut_Down
						.endif
						.BREAK
					.ENDIF
				.ENDW
			;multiple sel
			.ELSE
				INVOKE	SendMessage,		hWnd_Edit_CrtFile,WM_SETTEXT,0,ADDR SelMult
				INVOKE	SendMessage,		hWnd_Edit_MaskFile,WM_SETTEXT,0,ADDR SelMult
				mov		esi,				pBuffer_1000h
				add		esi,				900h
				mov		dword ptr [esi+ 0],		0
				mov		dword ptr [esi+ 4],		0
				mov		dword ptr [esi+ 8],		0
				mov		dword ptr [esi+12],		0
				mov		(strButPrp ptr [ebx+But_PasAdd]).Enabled,		Enabled_FALSE
				mov		(strButPrp ptr [ebx+But_PasDel]).Enabled,		Enabled_FALSE
				mov		(strButPrp ptr [ebx+But_PasOutm]).Enabled,	Enabled_FALSE
				mov		(strButPrp ptr [ebx+But_PassInM]).Enabled,	Enabled_FALSE
				.WHILE	VarDW2>0
					.BREAK	.IF	(VarDW1==0)
					dec		VarDW2
					INVOKE	SendMessage,		hWnd_List_Gen,LB_GETSEL,VarDW2,0
					.IF		eax!=0
						INVOKE	SendMessage,	hWnd_List_Gen,LB_GETITEMDATA,VarDW2,0
						.IF		byte ptr [eax+Ptr_MExtra_Status]==MExtra_Status_Encoded
							mov		byte ptr [esi+0],		1
						.ELSE
							mov		byte ptr [esi+1],		1
						.ENDIF
						
						.IF		word ptr [eax+Ptr_MExtra_DimMaskName]==0
							mov		byte ptr [esi+4],		1
						.ELSE
							mov		byte ptr [esi+5],		1
						.endif
						
						dec		VarDW1
					.ENDIF
				.ENDW
				
				;all encoded
				.IF		dword ptr [esi+0]==0001h	
					mov		(strButPrp ptr [ebx+But_MaskAdd]).Enabled,		Enabled_FALSE
					mov		(strButPrp ptr [ebx+But_MaskDel]).Enabled,		Enabled_FALSE
					
					mov		(strButPrp ptr [ebx+But_StatEnc]).Status,			StatBut_Down
					mov		(strButPrp ptr [ebx+But_StatDcd]).Status,			StatBut_Up
				.ELSE
					mov		(strButPrp ptr [ebx+But_MaskAdd]).Enabled,		Enabled_TRUE
					mov		(strButPrp ptr [ebx+But_MaskDel]).Enabled,		Enabled_TRUE
					;all decoded
					.IF		dword ptr [esi+0]==0100h
						mov		(strButPrp ptr [ebx+But_StatEnc]).Status,			StatBut_Up
						mov		(strButPrp ptr [ebx+But_StatDcd]).Status,			StatBut_Down
					;both
					.ELSE
						mov		(strButPrp ptr [ebx+But_StatEnc]).Status,			StatBut_Up
						mov		(strButPrp ptr [ebx+But_StatDcd]).Status,			StatBut_Up
					.ENDIF
					
					;everybody has a mask
					.IF		dword ptr [esi+4]==0100h
						mov		(strButPrp ptr [ebx+But_MaskAdd]).Status,			StatBut_Down
						mov		(strButPrp ptr [ebx+But_MaskDel]).Status,			StatBut_Up
					;no one has a mask
					.ELSEIF	dword ptr [esi+4]==0001h
						mov		(strButPrp ptr [ebx+But_MaskAdd]).Status,			StatBut_Up
						mov		(strButPrp ptr [ebx+But_MaskDel]).Status,			StatBut_Down
					.ELSE
						mov		(strButPrp ptr [ebx+But_MaskAdd]).Status,			StatBut_Up
						mov		(strButPrp ptr [ebx+But_MaskDel]).Status,			StatBut_Up
					.ENDIF
				.ENDIF
			.ENDIF
		.ENDIF
		;maybe a loop?
		INVOKE	DrawButton,	hDCBuffMain,But_DelFiles,TRUE
		INVOKE	DrawButton,	hDCBuffMain,But_StatEnc,TRUE
		INVOKE	DrawButton,	hDCBuffMain,But_StatDcd,TRUE
		INVOKE	DrawButton,	hDCBuffMain,But_MaskAdd,TRUE
		INVOKE	DrawButton,	hDCBuffMain,But_MaskDel,TRUE
		INVOKE	DrawButton,	hDCBuffMain,But_PasAdd,TRUE
		INVOKE	DrawButton,	hDCBuffMain,But_PasDel,TRUE
		INVOKE	DrawButton,	hDCBuffMain,But_PassInM,TRUE
		INVOKE	DrawButton,	hDCBuffMain,But_PasOutm,TRUE
		
	.ENDIF
	INVOKE	SendMessage,	hWnd_Edit_CrtFile,WM_GETTEXTLENGTH,0,0
	INVOKE	SendMessage,	hWnd_Edit_CrtFile,EM_SETSEL,eax,0
	INVOKE	SendMessage,	hWnd_Edit_MaskFile,WM_GETTEXTLENGTH,0,0
	INVOKE	SendMessage,	hWnd_Edit_MaskFile,EM_SETSEL,eax,0
ret
ShowInterface endp

ShowInfos					proc	PozitieXY:DWORD, hWndCrt:DWORD
;show informations about the area above wich the mouse is in the info zone
LOCAL	RecT1		:RECT
	
	mov		eax,			hWndCrt
	cmp		eax,			-1
	;just redraw
	je		EffectiveDraw
	;choose the text
	.IF		hWndMain==eax
		INVOKE	HitTestBut,		PozitieXY
		.IF		eax==-1
			mov		eax,			OFFSET Inform_General
		.ELSEIF	esi==But_AddFiles
			mov		eax,			OFFSET Inform_B_AddFile
		.ELSEIF	esi==But_DelFiles
			mov		eax,			OFFSET Inform_B_RemFile
		.ELSEIF	esi==But_SelAll
			mov		eax,			OFFSET Inform_B_SellAll
		.ELSEIF	esi==But_InvSel
			mov		eax,			OFFSET Inform_B_InvSel
		.ELSEIF	esi==But_SelMul
			mov		eax,			OFFSET Inform_B_MultSel
		.ELSEIF	esi==But_StatEnc
			mov		eax,			OFFSET Inform_B_Encode
		.ELSEIF	esi==But_StatDcd
			mov		eax,			OFFSET Inform_B_Decode
		.ELSEIF	esi==But_MaskAdd
			mov		eax,			OFFSET Inform_B_AddMsk
		.ELSEIF	esi==But_MaskDel
			mov		eax,			OFFSET Inform_B_RemMsk
		.ELSEIF	esi==But_PasAdd
			mov		eax,			OFFSET Inform_B_AddPass
		.ELSEIF	esi==But_PasDel
			mov		eax,			OFFSET Inform_B_RemPass
		.ELSEIF	esi==But_PassInM
			mov		eax,			OFFSET Inform_B_PInM
		.ELSEIF	esi==But_PasOutm
			mov		eax,			OFFSET Inform_B_POutM
		.ELSE
			mov		eax,			OFFSET Inform_General
		.ENDIF
	.ELSEIF	hWnd_Edit_CrtFile==eax
		mov		eax,			OFFSET Inform_EB_RFile
	.ELSEIF	hWnd_Edit_MaskFile==eax
		mov		eax,			OFFSET Inform_EB_MFile
	.ELSEIF	hWnd_List_Gen==eax
		mov		eax,			OFFSET Inform_List
	.ELSE
		jmp		GetOutOfHere
	.ENDIF
	;same text => don't draw
	cmp		CrtInfoInDsp,	eax
	je		GetOutOfHere
	mov		CrtInfoInDsp,	eax
	
	EffectiveDraw:
	;prepare the area
	INVOKE	SelectObject,	hDCBuffMain,hBrs_BackMain
	INVOKE	GetStockObject,	NULL_PEN
	INVOKE	SelectObject,	hDCBuffMain,eax
	INVOKE	SetTextColor,	hDCBuffMain,Info_TxtColor
	INVOKE	GetClientRect,	hWndMain,ADDR RecT1
	;calculate the rect
	.IF		RecT1.right<0245h
		mov		RecT1.right,		0245h
	.endif
	.IF		RecT1.bottom<018Dh
		mov		RecT1.bottom,		018Dh
	.endif
	mov		eax,			RecT1.right
	shr		eax,			1
	add		eax,			Aliniam_Mid+5
	mov		RecT1.left,	eax
	mov		RecT1.top,		Poz_Y_FrameI+2
	sub		RecT1.right,	Align_Right+5
	sub		RecT1.bottom,	Align_Down+2
	;cover the area
	INVOKE	Rectangle,		hDCBuffMain,RecT1.left,RecT1.top,RecT1.right,RecT1.bottom
	;SHOW TEXT
	INVOKE	DrawText,		hDCBuffMain,CrtInfoInDsp,-1,ADDR RecT1,DT_EXPANDTABS or DT_LEFT or DT_WORDBREAK or DT_END_ELLIPSIS
	INVOKE	InvalidateRect,	hWndMain,ADDR RecT1,FALSE
	
GetOutOfHere:
ret
ShowInfos 				endp




















