;#########################################################################################################
;###################*******************************#######################################################
;###################  B L I N D         C R Y P T  #######################################################
;###################  blind_crypt.tnick@yahoo.com  #######################################################
;###################_______________________________#######################################################
;#########################################################################################################

;
;					# Visual obj.asm #
;
.386
OPTION casemap:none
.CODE

GraphObj_Create		proc
;it creates graphic objects
LOCAL	hDCPrincip		:DWORD
LOCAL	Latime			:DWORD
LOCAL	Inaltime		:DWORD
	
	;brush for main window's background
	INVOKE	CreateSolidBrush,	MainW_BackColor
	mov		hBrs_BackMain,		eax
	;main window's hDC
	INVOKE	GetDC,				hWndMain
	mov		hDCPrincip,			eax
	;compatible dc to be used as backbuffer
	INVOKE	CreateCompatibleDC,	hDCPrincip
	mov		hDCBuffMain,		eax
	;compatible bitmap. same purpose
	INVOKE	GetSystemMetrics,	SM_CYSCREEN
	mov		Inaltime,			eax
	INVOKE	GetSystemMetrics,	SM_CXSCREEN
	mov		Latime,				eax
	INVOKE	CreateCompatibleBitmap,hDCPrincip,Latime,Inaltime
	mov		hBtmBuffMain,		eax
	INVOKE	SelectObject,		hDCBuffMain,eax
	;let the DC go
	INVOKE	ReleaseDC,			hWndMain,hDCPrincip
	
	;set the backcolor
	INVOKE	GetStockObject,		NULL_PEN
	INVOKE	SelectObject,		hDCBuffMain,eax
	INVOKE	SelectObject,		hDCBuffMain,hBrs_BackMain
	INVOKE	Rectangle,			hDCBuffMain,0,0,Latime,Inaltime
	
	;brush for unpressed button
	INVOKE	CreateSolidBrush,	Button_UpColor
	mov		hBrs_ButUp,			eax
	;brush for pressed button
	INVOKE	CreateSolidBrush,	Button_DownColor
	mov		hBrs_ButDown,		eax
	;brush for disabled button
	INVOKE	CreateSolidBrush,	Button_DisablColor
	mov		hBrs_ButDisabl,		eax
	;pen, width 1
	INVOKE	CreatePen,PS_SOLID,1,SeparLineColor
	mov		hPen_Grey0C_1,		eax
	;pen, width 4
	INVOKE	CreatePen,PS_SOLID,4,00DBDBDBh;SeparLineColor
	mov		hPen_Grey0C_4,		eax
	
	INVOKE	SetBkMode,			hDCBuffMain,TRANSPARENT
	
	;fonts
	INVOKE	GetStockObject,		ANSI_VAR_FONT
	mov		hFnt_Buttons,		eax
	INVOKE	CreateFontIndirect,	ADDR Comic_Sans_MS_9
	mov		hFnt_Frames,		eax
	mov		hFnt_Labels,		eax
	
	
mov	eax,1
ret
GraphObj_Create 		endp

GraphObj_Destroy	proc
;it destroy graphic objects
	
	INVOKE	DeleteObject,		hBrs_ButUp
	INVOKE	DeleteObject,		hBrs_ButDown
	INVOKE	DeleteObject,		hPen_Grey0C_1
	INVOKE	DeleteObject,		hPen_Grey0C_4
	
	INVOKE	DeleteObject,		hBrs_BackMain
	INVOKE	DeleteObject,		hBtmBuffMain
	INVOKE	DeleteDC,			hDCBuffMain
	
ret
GraphObj_Destroy	endp
